#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "desc";
$desc = "Descriptive Statistics";
$revision = "$Revision: 1.18 $$ ";

%F = &formdata ($pgm);

$F{'vars'} = 1 unless $F{'vars'};

$F{'example'} && &example(); # defined below
$F{'data'} = &getRand($F{'rand'}, $F{'vars'}) if $F{'rand'};

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc);
	&middleForm(); # defined below
	&endForm("Enter values separated by spaces or newlines", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("s", "Show Statistics");
		&optBool("o", "Order Statistics");
		&optBool("v", "Name=Value Format");
		&beginSection("Significance Tests", "inner");
			&optVal("t", "t-test against");
			&optVal("F", "F-test against");
		&endSection();
	&endSection();
	&beginSection("Histograms and Tables", "top");
		&optBool("h", "Histogram");
		&optBool("f", "Frequencies");
		&optBool("p", "Proportions");
		&optBool("c", "Cumulative");
		&beginSection("Formatting and Filtering", "inner");
			&optVal("i", "Interval");
			&optVal("m", "Minimum");
			&optVal("M", "Maximum");
		&endSection();
	&endSection();
}

sub example {
	$F{'rand'} = 250;
	$F{'i'} = 0.5;
	$F{'m'} = '-3.75';
	$F{'M'} = '3.75';
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'o'} = $F{'h'} = $F{'c'} = $F{'f'} = $F{'p'} = 'checked';
	$F{'F'} = 0;
	$F{'rows'} = 3;
	$F{'cols'} = 40;
}

