# $Revision: 1.25 $

sub getTime # [yearonly]
{
	local ($yearonly) = (@_);
	local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
		localtime;
	return($year+1900) if $yearonly;
	local ($timestring);
	$timestring = sprintf ("%02d-%02d-%02d %02d:%02d:%02d",
		$year+1900, $mon+1, $mday, $hour, $min, $sec);
	return ($timestring, $wday);
}

sub encode {
	local ($str) = (@_);
	# $str =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
	$str =~ s/(\W)/sprintf("%%%02X", ord($1))/seg;
	return $str;
}

sub formdata1 { # nil -> %F
    local (*formdata);
    if ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read (STDIN, $F, $ENV{'CONTENT_LENGTH'});
    } else {
        $F = $ENV{'QUERY_STRING'};
    }
    @formdata = split (/&/, $F);
    for (@formdata) {
        local ($name, $value) = split (/=/, $_, 2);
        $value =~ s/\+/ /g;
        $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;
        $F{$name} .= "\n" if $F{$name};
        $F{$name} .= $value;
    }
	$F{'clear'} && clearForm();
    return (%F);
}

sub clearForm {
	local ($f);
	for $f (keys (%F)) {
		$F{$f} = "";
	}
}

sub formdata { # [ident] -> %F
	local ($ident) = (@_);
    local (*formdata);
    if ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read (STDIN, $F, $ENV{'CONTENT_LENGTH'});
    } else {
        $F = $ENV{'QUERY_STRING'};
		if (($F eq "") && $ident) {
			$F = $ENV{'HTTP_COOKIE'};
			# print "<pre>xyzzy got cookie: $F</pre>\n";
			if ($F =~ /.*$ident=([^;]*)/) { # $ident is cookie name
				$F = $1;
				$F =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg; # decode
				# now $F looks like a=xxx&b=yyy&c=zzz
			}
		}
    }
    @formdata = split (/&/, $F);
    for (@formdata) {
        local ($name, $value) = split (/=/, $_, 2);
        $value =~ s/\+/ /g;
        $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;
        $F{$name} .= "\n" if $F{$name};
        $F{$name} .= $value;
    }
	$F{'clear'} && clearForm();
    return (%F);
}

sub clean {
	local ($s) = (@_);
	$s =~ s/['"<>!|\\;]//g;
}

sub makeCmd { # must be run after form has been displayed
	local ($options, $cmd, $opt);
	$options = "";
	for $opt (@options) {
		if ($isBoolean{$opt}) {
			$options .= " -$opt" if $F{$opt};
		} elsif ($opt ne "parms") {
			$options .= " -$opt '$F{$opt}'" if $F{$opt};
		}
	}
	if ($F{'parms'}) {
		local ($parm, @parms);
		@parms  = split /\s+/, $F{'parms'};
		for $parm (@parms) {
			$options .= " '$parm'";
		}
	}
	local ($dir) = "./";
	$options =~ s/[<>();&`]//g; # remove special characters for security
	$cmd = "/bin/echo \"$F{'data'}\" | $dir$pgm $options |";
	return ($options, $cmd);
}

sub runCmd { # pgm cmd F
	local ($pgm, $cmd) = (@_);
	if ($F{'data'} || $F{'L'} || $F{'O'} || $F{'V'}) {
		open (PIPE, $cmd) or die "can't open pipe";
		local ($lines) = 0;
		print "<pre title=\"$pgm $options\">\n";
		while (<PIPE>) {
			print;
			$lines++;
		}
		close PIPE;
		if ($lines) { # successful analysis
			$ip = $ENV{'REMOTE_ADDR'};
			if ($ip =~ /^63.118/) { # Verizon robot
			    $skip = 1;
			}
			if (!$skip && open (LOG, ">>.$pgm.cgi")) {
				local ($NOW, $wday) = &getTime ();
				print LOG $wday; # save the day of the week for tracking usage
				close LOG;
			}
		} else {
			print "<font color=red><b>No output from $pgm. Maybe there is an error in the data?</b></font>\n";
		}
		print "</pre>\n";
	}
}

sub beginPage {
	local ($pgm, $desc) = (@_);
	print "Content-type: text/html\r\n\r\n";
	print "<html lang=\"en\">
	<head>
		<title>$pgm: $desc</title>
		<link rel=\"stylesheet\" href=\"stat.css\" type=\"text/css\"/>
		<script language=\"JavaScript\" src=\"stat.js\" type=\"text/javascript\"></script>
	</head>
	<body bgcolor= \"#FFFFFF\">
	<h1>$pgm: $desc</h1>
	";
	&saveCookie($pgm);
}

sub endPage {
	print "</body></html>\n";
}

sub optVal { # name label size
	local ($name, $label, $size) = (@_);
	@options = (@options, $name);
	$size = 4 unless $size;
	print "<nobr>";
	print "<label class=\"normal\" for=\"$label\">";
	print "$label:";
	print "</label>";
	print "<input type=\"text\" size=\"$size\" name=\"$name\" id=\"$label\" value=\"$F{$name}\" >";
	print "</nobr>\n";
}

sub optBool { # name label 
	local ($name, $label) = (@_);
	$isBoolean{$name} = 1;
	@options = (@options, $name);
	print "<nobr>";
	print "<input type=\"checkbox\" name=\"$name\" value=\"checked\" id=\"$label\" $F{$name} />";
	print "<label class=\"normal\" for=\"$label\">";
	print "$label";
	print "</label>";
	print "</nobr>\n";
}

sub optMenu { # name label value lable value label ...
	local ($name, $label, @options) = (@_);
	print "<nobr>";
	print "<label class='normal' for='$name'>$label</label>\n";
	print "<select id='$name' name='$name'>\n";
	local ($value);
	for $option (@options) {
		($value, $label) = split (/=/, $option);
		if ($F{$name} eq $value) {
			$selected = " selected='selected'";
		} else {
			$selected = '';
		}
		print "\t<option value='$value'$selected>$label</option>\n";
	}
	print "</select>";
	print "</nobr>\n";
}

sub beginSection { # label
	local ($label, $level) = (@_);
	$level = "top" unless $level;
	print "<fieldset class=\"$level\"> <legend>$label</legend>\n";
}

sub endSection {
	print "</fieldset>\n";
}

sub dataArea {
	local ($msg, $rand) = (@_);
	$msg = "Enter numbers separated by space or newlines" unless $msg;
	$F{'rows'} = 5 unless $F{'rows'};
	$F{'cols'} = 50 unless $F{'cols'};
	$plus = "<tt style=\"border: 1px solid blue\">+</tt>";
	$minus = "<tt style=\"border: 1px solid blue\">-</tt>";
	$or = " ";
	 
	print "
	<fieldset>
	<legend><label for=data>Data</label></legend>
	<textarea title=\"$msg\" name=data id=data rows=$F{'rows'} cols=$F{'cols'} wrap=virtual>$F{'data'}</textarea>
	<div>
	 
	<fieldset class=inner>
	<legend>Data Entry Options</legend>
	<label class=normal for=rows>Height:</label><input type=text name=rows onChange=\"update(0,0);\" id=rows size=2 value=\"$F{'rows'}\">
	<a title=\"add a row\" onclick=\"update(1,0);\">$plus</a>
		$or
	<a title=\"delete a row\" onclick=\"update(-1,0);\">$minus</a>
	&nbsp;
	<nobr>
		<label class=normal for=cols>Width:</label><input type=text name=cols onChange=\"update(0,0);\" id=cols size=2 value=\"$F{'cols'}\">
		<a title=\"wider\" onclick=\"update(0,5);\">$plus</a>
			$or
		<a title=\"narrower\" onclick=\"update(0,-5);\">$minus</a>
	</nobr>
	";
	$rand && print "
		&nbsp;
		<nobr>
			<label class=normal for=rand title=\"Use this many random normal values as the data\">Random Cases:</label><input type=text name=rand id=rand size=3 value=\"$F{'rand'}\">
		</nobr>
		&nbsp;
		<nobr>
			<label class=normal for=vars title=\"Use this many variables per case\">Variables:</label><input type=text name=vars id=vars size=2 value=\"$F{'vars'}\">
		</nobr>
	";
	print "</fieldset>
	</fieldset>
	</div>\n";
}

sub beginForm {
local ($pgm, $desc, $other) = (@_);
print "
<form name=form method=POST onLoad=\"setFocus();\" action=\"$pgm.cgi\">
	<input type=submit accesskey=r title=\"accesskey: r\" name=run value=\"Run $pgm\">
	<input type=submit accesskey=c title=\"accesskey: c\" name=clear onClick=\"clearForm('$pgm', document.form); return false;\" value=\"Clear\">
	<font size=2>
	<a target=new title=\"Display the manual entry for $pgm in another window\" href=\"../doc/$pgm.htm\">Help</a>
|
	<a target=new title=\"Show an example in a new window\" href=\"$ENV{'SCRIPT_NAME'}?example=true\">Example</a>
|
	<a target=new title=\"Display the |STAT home page in another window\" href=\"..\">Home</a>
<!--|
	<a title=\"Download Linux binary\" type=\"application/octet-stream\" href=\"$pgm\">Binary</a>
	-->
|
	<a title=\"Privacy Policy\" href=\"index.htm#privacy\">Privacy</a>
";

	if ($other) { # another program
		local (@others) = split (/,/, $other);
		for $other (@others) {
			local ($pgm) = $other;
			$pgm =~ s/[&].*$//;
			print "|
				<a href=\"$pgm.cgi\" title=\"Copy this screen to $pgm\" onClick=\"other('$other'); return false;\">$pgm</a>\n";
		}
	}
	print "</font><p>\n";
}

sub endForm { # showData
	local ($showData, $rand) = (@_);
	if ($never) {
	  &beginSection("Help Options", "top");
		&optBool("L", "Show Limits");
		&optBool("O", "Show Options");
		&optBool("V", "Show Version");
	  &endSection();
	}
	&dataArea($showData, $rand) if $showData;
	print "</form>\n";
}

sub isSaved {
	local ($opt) = (@_);
	($opt eq 'parms') && return 1;
	($opt eq 'rows') && return 1;
	($opt eq 'cols') && return 1;
	($opt eq 'data') && return 0; # TODO: check size?
	($opt eq 'rand') && return 0;
	($opt eq 'vars') && return 0;
	($opt eq 'example') && return 0;
	($opt eq 'run') && return 0;
	($opt =~ /^[LOV]$/) && return 0;
	($opt =~ /^\w$/) && return 1;
	return false;
}

sub saveCookie {
	local ($ident) = (@_);
	$ident = "stat" unless $ident;
	local ($f);
	for $f (keys (%F)) {
		if (&isSaved($f)) {
			$url .= "$f=" . &encode($F{$f}) . "&";
		}
	}
	print "<script language=\"JavaScript\">
		setCookie(\"$ident\", \"$url\", 1);
	</script>\n";
}

sub getRand { # n
	local ($n, $vars) = (@_);
	local ($total) = $n * $vars;
	local ($cmd) = "./probdist r n $total |";
	local ($data, $value);
	if (open (RAND, $cmd)) {
		while (<RAND>) {
			chop;
			$data .= sprintf("%10.6f", $_);
			$total--;
			if (($total % $vars) == 0) {
				$data .= "\n";
			} else {
				$data .= " ";
			}
		}
		# print "<div>$data</div>";
		close RAND;
		return $data;
	}
}

1;
