#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "features";
$desc = "Feature Tabulation";
$revision = "$Revision: 1.3 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'example'} && &example(); # defined below
if ($F{'rand'}) {
	$F{'data'} = &getRand($F{'rand'}, $F{'vars'});
	$F{'parms'} = "A B C D E F G H I J";
}

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc);
	&middleForm(); # defined below
	&endForm("Enter one item name per line, followed by features.", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection("Options", "top");
		&optVal('c', "Column Separator String", 4);
		&optVal('p', "Page Size", 4);
		&optVal('i', "Item Label Width", 4);
		&optVal('l', "Leader Character After Label", 4);
		&optVal('w', "Width of Feature Columns", 4);
		&optVal('n', "String Indicating 'NO'", 4);
		&optVal('y', "String Indicating 'YES'", 4);
		&optBool('h', "Horizontal Format for Header");
		print "\n<br>";
		&optVal("parms", "Variable Names", 60);
		&optVal('desc', 'Analysis Name', 20);
	&endSection();
}

sub example {
	local ($data);
	$data .= "BrandX    price=Med reliable finish=Wood capacity=4
BrandY    price=High finish=Metal capacity=2
BrandZ    price=Low finish=Wood capacity=4";
	$F{'data'} = $data;
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'parms'} = "Price=4 Reliable Finish=6 Capacity";
}

