#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "pair";
$desc = "Paired Data Analysis";
$revision = "$Revision: 1.2 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'vars'} = 2 unless $F{'vars'};

$F{'example'} && &example(); # defined below
$F{'data'} = &getRand($F{'rand'}, $F{'vars'}) if $F{'rand'};

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc, "rankrel,regress");
	&middleForm(); # defined below
	&endForm("Enter two values per line, separated by spaces", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("s", "Show Statistics");
		&optBool("p", "Show Plot");
		&optBool("f", "Hide Plot Frame");
		&beginSection("Data Names", "inner");
			&optVal("x", "X-axis Name", 20);
			&optVal("y", "Y-axis Name", 20);
		&endSection();
		&beginSection("Plot Size", "inner");
			&optVal("w", "Width");
			&optVal("h", "Height");
			&optVal("c", "Plotting Character", 1);
		&endSection();
		&beginSection("Minimum Values", "inner");
			&optVal("l", "Min X-axis Value");
			&optVal("b", "Min Y-axis Value");
		&endSection();
		&beginSection("Maximum Values", "inner");
			&optVal("r", "Max X-axis Value");
			&optVal("t", "Max Y-axis Value");
		&endSection();
	&endSection();
}

sub example {
	local ($data);
	for $i (1 .. 100) {
		$data .= "$i	" . 15*log($i) . "\n";
	}
	$F{'data'} = $data;
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'p'} = $F{'s'} = "checked";
	$F{'x'} = "Linear";
	$F{'y'} = "Natural Logarithm";
	$F{'rows'} = 3;
	$F{'cols'} = 30;
}

