#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "probdist";
$desc = "Probability Distribtions";
$revision = "$Revision: 1.2 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'vars'} = 2 unless $F{'vars'};

$F{'example'} && &example(); # defined below
$F{'data'} = &getRand($F{'rand'}, $F{'vars'}) if $F{'rand'};

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc);
	&middleForm(); # defined below
	&endForm("");

	($options, $cmd) = &makeCmd();
	$cmd = "$pgm";
	$cmd .= " -s $F{'s'}" if ($F{'s'});
	$cmd .= " -q" if ($F{'q'});
	$cmd .= " -v" if ($F{'v'});
	$cmd .= " $F{'func'} $F{'dist'} $F{'val'}";
	$cmd =~ s/[<>|;&`]//g;
	$F{'data'} = "$cmd";
	&runCmd($pgm, $pgm);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("q", "Quick version");
		&optBool("v", "Verbose output");
	&endSection();
	&beginSection("Probability Functions", "xyz");
		&optMenu("func", "Distribution Function",
			"prob=Probability of Obtained Statistic", 
			"crit=Critical Statistic Value",
			"rand=Random Samples of Distribution Values");
		print "<br/>\n";
		&optMenu("dist", "Probability Distribution",
			"uniform=Uniform Distribution ([0-1])",
			"binomial=Binomial Distribution",
			"normal=Normal (Z) Distribution",
			"chi=Chi-Square (&Chi;&sup2;) Distribution",
			"F=F Distribution",
			"t=Student t Distribution");
		print "<br/>\n";
		&optVal("val", "Value for Distribution Function", 10);
		print "<br/>\n";
		&optVal("s", "Integer seed for random number generation", 10);
	&endSection();
}

sub example {
	local ($data);
	for $i (1 .. 100) {
		$data .= "$i	" . 15*log($i) . "\n";
	}
	$F{'data'} = $data;
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'p'} = $F{'s'} = "checked";
	$F{'x'} = "Linear";
	$F{'y'} = "Natural Logarithm";
	$F{'rows'} = 3;
	$F{'cols'} = 30;
}

