#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "rankind";
$desc = "Rank Order Analysis for Independent Groups";
$revision = "$Revision: 1.2 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'vars'} = 3 unless $F{'vars'};
$F{'s'} = -1 unless $F{'s'};

$F{'example'} && &example(); # defined below
if ($F{'rand'}) {
	$F{'data'} = &getRand($F{'rand'}, $F{'vars'});
	$F{'parms'} = "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z";
}

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc, "oneway&parms&s&p");
	&middleForm(); # defined below
	&endForm("Enter values separated by spaces or newlines. Separate groups with the splitter value.", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("p", "Plot Conditions");
		&optBool("r", "Report Average Ranks");
		# &optBool("y", "Do Not Use Yates' Correction");
		print "\n<br>";
		&optVal("s", "Splitter Value");
		# &optVal('w', "Plot Width", 2);
		print "\n<br>";
		&optVal("parms", "Group Names", 60);
	&endSection();
}

sub example {
	local ($i, $group, $data);
	local ($bart) = 20 + int(rand(30));
	local ($lisa) = 20 + int(rand(20));
	local ($maggie) = 20 + int(rand(40));
	for $group ($bart, $lisa, $maggie) {
		for $i (1 .. $group) {
			$data .= sprintf("%6.3f ", rand);
		}
		$data .= "$F{'s'}\n";
	}
	$F{'data'} = $data;
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'parms'} = "bart lisa maggie";
	$F{'p'} = "checked";
	$F{'rows'} = 3;
	$F{'cols'} = 50;
}

