#! /usr/local/bin/perl

# TODO automatically increase -c to accept data

require "./stat.pl";

$pgm = "rankrel";
$desc = "Rank Order Analysis for Related Samples";
$revision = "$Revision: 1.2 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'vars'} = 4 unless $F{'vars'};
$F{'c'} = 100 unless $F{'c'};

$F{'example'} && &example(); # defined below
if ($F{'rand'}) {
	$F{'data'} = &getRand($F{'rand'}, $F{'vars'});
	$F{'parms'} = "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z";
}

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc, "regress&parms,pair");
	&middleForm(); # defined below
	&endForm("Enter N values (one for each variables) per line, separated by spaces, starting with the predicted variable.", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("r", "Report Average Ranks");
		&optBool("s", "Stop Significance Tests");
		# &optBool("y", "Do Not Use Yates' Correction");
		print "\n<br>";
		&optVal('c', "Maximum Cases", 3);
		print "\n<br>";
		&optVal("parms", "Variable Names", 60);
	&endSection();
}

sub example {
	local ($data);
	for $i (1 .. 25) {
		$data .= sprintf("%4d %8.4f %8.4f %8.4f\n", $i, log($i), 1/$i, sqrt($i));
	}
	$F{'data'} = $data;
	$F{'r'} = 'checked';
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'parms'} = "x   log(x)   1/x   sqrt(x)";
	$F{'rows'} = 3;
	$F{'cols'} = 50;
}

