#! /usr/local/bin/perl

require "./stat.pl";

$pgm = "regress";
$desc = "Multiple Regression";
$revision = "$Revision: 1.2 $$ ";

%F = &formdata ($pgm);
$desc = $F{'desc'} if $F{'desc'};

$F{'vars'} = 4 unless $F{'vars'};
# $F{'F'} = 10 unless $F{'F'};

$F{'example'} && &example(); # defined below
if ($F{'rand'}) {
	$F{'data'} = &getRand($F{'rand'}, $F{'vars'});
	$F{'parms'} = "A B C D E F G H I J";
}

&beginPage($pgm, $desc);

	&beginForm($pgm, $desc, "rankrel&parms");
	&middleForm(); # defined below
	&endForm("Enter N values (one for each variable) per line, separated by spaces, starting with the predicted variable.", 1); # include data entry area

	($options, $cmd) = &makeCmd();
	&runCmd($pgm, $cmd);

&endPage();

sub middleForm {
	&beginSection($desc, "top");
		&optBool("p", "Partial Correlation");
		&optBool("r", "Hide Regression");
		&optBool("c", "Covariance Matrix");
		&optBool("s", "Sums of Squares");
		# print "\n<br>";
		# &optVal('F', "Format Width", 2);
		print "\n<br>";
		&optVal("parms", "Variable Names", 60);
	&endSection();
}

sub example {
	local ($data);
	for $i (1 .. 25) {
		$data .= sprintf("%4d %8.4f %8.4f %8.4f\n", $i, log($i), 1/$i, sqrt($i));
	}
	$F{'data'} = $data;
	$F{'L'} = $F{'O'} = $F{'V'} = "";
	$F{'parms'} = "x   log(x)   1/x   sqrt(x)";
	$F{'rows'} = 3;
	$F{'cols'} = 50;
}

