<p>
<div align=center>
<table cellpadding=5 style="border: solid gray 1px; background: #FFFFEE" name=handbook border=0>
<tr valign=top>
<td>
	<img src="statlogo.gif" height="400" alt="STAT logo">
</td>
<td nowrap align=right>
	<font size=6>
	<B>The |STAT Handbook</B>
	</font>
	<br>
	<font size=5>
	Data Analysis Programs
	<br>
	on UNIX and MSDOS
	<font size="4" color="#999999" ><br>and on Linux and Mac OS</font>
	<p>
	Gary Perlman
	</font>
<p>
	<table border=1 cellpadding=2 cellspacing=0>
		<tr><th bgcolor="#FFFFEE" align=left>
		Handbook Chapters</th></tr>
		<tr><td align=left>
		<font size=2>
		<a href="preface.html" title="business, legal, references">Preface</a>
		<br><a href="intro.html" title="just a taste">Introduction to the Package</a>
		<br><a href="example.html" title="an analysis of some fake data">Annotated Example</a>
		<br><a href="conventions.html" title="consistent conventions">Conventions Used in the Package</a>
		<br><a href="manipulation.html" title="tutorial information about data manipulation programs">Data Manipulation Programs</a>
		<br><a href="analysis.html" title="tutorial information about analysis programs">Data Analysis Programs</a>
		<br><a href="dm.html" title="Data Manipulation">DM Manual</a>
		<br><a href="calc.html" title="algebraic calculator">CALC Manual</a>
		<br><a href="introman.html" title="Links to program manual entries">Program Manual Entries</a>
</font>
	</td></tr></table>
</td>
</tr>
</table>
</div>

<h2 id='home'>|STAT Home Page</h2>

   <UL>
      <li><a href="#news">|STAT News</a>
      <li><a href="#features">Package Features</a>
      <li><a href="#manipprog">Data Manipulation Programs</a>
      <li><a href="#manipfeat">Data Manipulation Program Highlights</a>
      <li><a href="#analprog">Data Analysis Programs</a>
      <li><a href="#access"><b>Obtaining |STAT</b></a>
      <UL>
         <li><b>DOS Version of |STAT</b>
      </UL>
      <li><a href="#conditions">Distribution Conditions</a>
      <li><a href="#notes">Notes</a>
   </UL>


|STAT is a set of about
<a href='/perlman/stat/doc/intro.htm'>
30 data manipulation and analysis programs
</a>
developed by Gary Perlman at the University of California, San
Diego and at the Wang Institute.  The manipulation programs are
general utilities that work with other standard programs like
<tt>sort</tt>. 
The analysis programs compute most widely used statistics.  |STAT
programs are designed with the philosophy that individual programs
should be designed as tools that do one task well and produce
output suitable for input via pipes to |STAT and other programs. 
Interactive use is supported in the command line interpreter/editor
while batch files or shell scripts provide a programming language
for complex analyses.  Typical usage involves a pipeline of
transformations of data followed by input to an analysis program,
summarized schematically by:

<pre>
INPUT DATA | TRANSFORM | ANALYSIS | OUTPUT RESULTS 
</pre>

<h2 id='news'>|STAT News</h2>
<ul compact>
	<li class="new">
		<b>|STAT turns 35!</b>
		It was an autumn day in 1979 when I skipped a class to implement the histogram scaling algorithm
		for the first stat program, <tt>hist</tt>, which was eventually incorporated into
		<a href='/perlman/stat/doc/desc.htm'><tt>desc</tt></a>.
	</li>
	<li><b>Sun SPARC Executables</b>
		<br>Compiled SunOS versions from 1996 are available in a
		<a href="/perlman/stat/sunstat.zip">zip</a> or
		<a href="/perlman/stat/sunstat.tar">tar</a> archive.
	<li><b>Web Forms for Analysis Programs</b>
		<br>Now you can do some quick analysis from your web browser.
			Each form has a link to create an example run.
			See the <nobr><a href="form"><b>|STAT Web Forms Page</b></a></nobr>.
	<li><b>Documentation on the Web</b>	
		<br>The original |STAT handbook and program manual entries are
		available the Web.
		<ul>
			<li><a href="handbook/handbook.html">Handbook (single HTML file)</a>
			or
			<a href="handbook.pdf">Handbook (single PDF file)</a>
			<li><a href="doc/">Program Manual Entries</a>
		</ul>
	<li><b>DOS |STAT available!</b>
		The compiled DOS version of |STAT is available
		along with documentation in a
		<a href="/perlman/stat/DOS-STAT.ZIP">WinZip archive</a>.
	<li><b>DOS |STAT turns 20!</b>
		In 1986, Fred Horan at Cornell and I ported the code to the PC.
	<li><b>UNIX |STAT turns 25!</b>
		The first |STAT program,
		<a href='/perlman/stat/doc/desc.htm'>desc</a>,
		was created in late October of 1979;
		<a href='/perlman/stat/doc/anova.htm'>anova</a>
		was created April 1980.
	<li>
		An <b>early (1982) paper on the main design ideas in |STAT</b>
		as available at:
		<a href='../statmdf.html'
			>statmdf.html</a>
	<li>Nice <b>online statistics book</b>:
		<a target="new" href='http://davidmlane.com/hyperstat/'
			>HyperStat, by David M. Lane</a>
	<li>Another suite of programs using pipes (for
		digital signal processing and auditory modelling):
		<a target="new" href="http://psych.cf.ac.uk/contactsandpeople/academics/culling.php"
			>|WAVE, by John Culling</a>
</ul>

<h2 id='features'>Package Features</h2>
<ul>
 <li> simple input formats (free-format field-oriented)
 <li> flexible data manipulation
 <li> several simple lineprinter plotting options
 <li> data validation (range and type checking)
 <li> consistent option conventions with online help
 <li> compiles and runs on any UNIX System
   (V6, V7, 2.8 BSD, 4.x BSD, System V, ANSI, etc.)
 <li> runs on MSDOS/PCDOS 2.x, 3.x, 4.x, 5.x with
 	<span title="That's right, you need 96K of memory to run the programs">96K</span>
   (IBM, AT&amp;T, Epson, and all compatibles)
 <li> usually less than a few seconds per analysis
 <li> liberal copyright (but can't be distributed for gain)
 <li> in use at <span title="probably thousands">hundreds</span> of university, industry, government and
   research sites for over 20 years
</ul>

 <h2 id='manipprog'>Data Manipulation Programs</h2>

<table border=0 cellspacing=0 cellpadding=2>
<tr valign=top><td>
	<a href='/perlman/stat/doc/abut.htm'>abut</a>
<td>       join data files beside each other
<tr valign=top><td>
	<a href='/perlman/stat/doc/colex.htm'>colex</a>
<td>      column extraction/formatting
<tr valign=top><td>
	<a href='/perlman/stat/doc/dm.htm'>dm</a>
<td>         conditional data extraction/transformation
<tr valign=top><td>
	<a href='/perlman/stat/doc/dsort.htm'>dsort</a>
<td>      multiple key data sorting filter
<tr valign=top><td>
	<a href='/perlman/stat/doc/linex.htm'>linex</a>
<td>      line extraction
<tr valign=top><td>
	<a href='/perlman/stat/doc/maketrix.htm'>maketrix</a>
<td>   make matrix format from free-format input
<tr valign=top><td>
	<a href='/perlman/stat/doc/perm.htm'>perm</a>
<td>       random/numerical/alphabetical permutation
<tr valign=top><td>
	<a href='/perlman/stat/doc/probdist.htm'>probdist</a>
<td>   probability distribution functions
<tr valign=top><td>
	<a href='/perlman/stat/doc/ranksort.htm'>ranksort</a>
<td>   convert data to ranks
<tr valign=top><td>
	<a href='/perlman/stat/doc/repeat.htm'>repeat</a>
<td>     repeat strings or lines in files
<tr valign=top><td>
	<a href='/perlman/stat/doc/reverse.htm'>reverse</a>
<td>    reverse lines, columns, or characters
<tr valign=top><td>
	<a href='/perlman/stat/doc/series.htm'>series</a>
<td>     generate an additive series of numbers
<tr valign=top><td>
	<a href='/perlman/stat/doc/transpose.htm'>transpose</a>
<td>  transpose matrix format input
<tr valign=top><td>
	<a href='/perlman/stat/doc/validata.htm'>validata</a>
<td>   verify data file consistency
</table>

<h2 id='manipfeat'>Data Manipulation Program Highlights</h2>

<ul>
 <li> conditional extraction of rows or columns
 <li> data sorting based on multiple keys 
 <li> line permutation (random and sorted)
 <li> matrix formation and transposition functions 
 <li> conversion of data to ranks 
 <li> additive series generation + 6 distributions:
   uniform, normal, t, chi-square, F, binomial
 <li> input validation for format and data types
 <li> text pagination and formatting with headers
 <li> ASCII file archiver for file combination and transfer 
</ul>

<h2 id='analprog'>Data Analysis Programs</h2>

<table border=0 cellspacing=0 cellpadding=2>
<tr valign=top><td>
	<a href='/perlman/stat/doc/anova.htm'>anova</a>
<td>      multi-factor analysis of variance, plots
<tr valign=top><td>
	<a href='/perlman/stat/doc/calc.htm'>calc</a>
<td>       interactive algebraic modeling calculator
<tr valign=top><td>
	<a href='/perlman/stat/doc/contab.htm'>contab</a>
<td>     contingency tables and chi-square
<tr valign=top><td>
	<a href='/perlman/stat/doc/desc.htm'>desc</a>
<td>       descriptions, histograms, frequency tables
<tr valign=top><td>
	<a href='/perlman/stat/doc/dprime.htm'>dprime</a>
<td>     signal detection d' and beta calculations
<tr valign=top><td>
	<a href='/perlman/stat/doc/features.htm'>features</a>
<td>   tabulate features of items
<tr valign=top><td>
	<a href='/perlman/stat/doc/oneway.htm'>oneway</a>
<td>     one-way anova/t-test, error-bar plots
<tr valign=top><td>
	<a href='/perlman/stat/doc/pair.htm'>pair</a>
<td>       paired data statistics, regression, plots 
<tr valign=top><td>
	<a href='/perlman/stat/doc/rankind.htm'>rankind</a>
<td>    independent conditions rank order analysis
<tr valign=top><td>
	<a href='/perlman/stat/doc/rankrel.htm'>rankrel</a>
<td>    related conditions rank order analysis
<tr valign=top><td>
	<a href='/perlman/stat/doc/regress.htm'>regress</a>
<td>    multiple linear regression and correlation
<tr valign=top><td>
	<a href='/perlman/stat/doc/stats.htm'>stats</a>
<td>      simple summary statistics
<tr valign=top><td>
	<a href='/perlman/stat/doc/ts.htm'>ts</a>
<td>         time series analysis, plots
</table>

<h2 id='access'>Obtaining |STAT</h2>

Instructions updated: 2001-05-12
<p>
|STAT is no longer available via e-mail or FTP.
It is now stored at an unadvertized Web address.
The file:
   stat.tar.Z
is compressed, tar archive of the package.
To unpack the archive, you need uncompress or zcat, and tar.
To ensure that the distribution restrictions
on |STAT are maintained, you must request the location of the file from
<a href="mailto:perlman@acm.org?subject=|STAT request">perlman@acm.org</a>
with a message containing:
<pre>
   I AGREE TO ADHERE TO THE CONDITIONS OF USING |STAT.
   I AGREE NOT TO SHARE THE |STAT LOCATION WITH OTHERS.
</pre>
<b>Please include a subject with |STAT in it or the spam filters may
not let your request through.</b>
<p>
After obtaining the file
you should run the following commands:
<pre>
   uncompress stat.tar.Z  # to create stat.tar
   tar xvf stat.tar       # to extract the files
</pre>
You should then have a stat directory that will take up about a
megabyte.  In the stat/src directory, you should make any necessary
changes to the makefile and then run make to build the package.
<a href="installation.txt">Installation notes</a> are available.
In addition to the online manuals,
the file <a href="/perlman/stat/handbook/handbook.html">handbook.html</a> contains an
HTML version of the |STAT handbook,
which is also available in <a href="handbook.pdf">PDF format</a>.
<p>
<h3>DOS Version of |STAT</h3>
<p>
The compiled
<a href="/perlman/stat/DOS-STAT.ZIP"
><b>DOS version of |STAT</b></a> (with documentation) is available in a WinZip archive.
No permission or password is needed to access the DOS version,
but a note informing
<a href="mailto:perlman@acm.org?subject=DOS|STAT notice">perlman@acm.org</a>
would be appreciated.

<h2 id='conditions'>Distribution Conditions</h2>

CAREFULLY READ THE FOLLOWING CONDITIONS.  IF YOU DO NOT FIND THEM
ACCEPTABLE, YOU SHOULD NOT USE |STAT.
<p>
   |STAT IS PROVIDED "AS IS," WITHOUT ANY EXPRESS OR IMPLIED
WARRANTY.  THE USER ASSUMES ALL RISKS OF USING |STAT.  THERE IS NO
CLAIM OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
|STAT MAY NOT BE SUITED TO YOUR NEEDS.  |STAT MAY NOT RUN ON YOUR
PARTICULAR HARDWARE OR SOFTWARE CONFIGURATION.  THE AVAILABILITY OF
AND PROGRAMS IN |STAT MAY CHANGE WITHOUT NOTICE.  NEITHER
MANUFACTURER NOR DISTRIBUTOR BEAR RESPONSIBILITY FOR ANY MISHAP OR
ECONOMIC LOSS RESULTING THEREFROM OF THE USE OF |STAT EVEN IF THE
PROGRAMS PROVE TO BE DEFECTIVE.  |STAT IS NOT INTENDED FOR CONSUMER
USE.
<p>
   CASUAL USE BY USERS NOT TRAINED IN STATISTICS, OR BY USERS NOT
SUPERVISED BY PERSONS TRAINED IN STATISTICS, MUST BE AVOIDED. 
USERS MUST BE TRAINED AT THEIR OWN EXPENSE TO LEARN TO USE THE
PROGRAMS.  DATA ANALYSIS PROGRAMS MAKE MANY ASSUMPTIONS ABOUT DATA,
THESE ASSUMPTIONS AFFECT THE VALIDITY OF CONCLUSIONS MADE BASED ON
THE PROGRAMS.  REFERENCES TO SOME APPROPRIATE STATISTICAL SOURCES
ARE MADE IN THE |STAT HANDBOOK AND IN THE MANUAL ENTRIES FOR
SPECIFIC PROGRAMS.  |STAT PROGRAMS HAVE NOT BEEN VALIDATED FOR
LARGE DATASETS, HIGHLY VARIABLE DATA, NOR VERY LARGE NUMBERS.
<p>
   You may make copies of any tangible forms of |STAT programs,
provided that there is no material gain involved, and provided that
the information in this notice accompanies every copy.  You may not
copy printed documentation unless such duplication is for non-
profit educational purposes.  You may not provide |STAT as an
inducement to buy your software or hardware or any products or
services.  You may distribute copies of |STAT, provided that mass
distribution (such as electronic bulletin boards or anonymous ftp)
is not used.  You may not modify the source code for any purposes
other than getting the programs to work on your system.  Any costs
in compiling or porting |STAT to your system are your's alone, and
not any other parties.  You may not distribute any modified source
code or documentation to users at any sites other than your own.



<h2 id='notes'>Notes</h2>

<ul>
<li>
   UNIX is a trademark of AT&amp;T, Novell, UNIX Systems Labs, or someone else.
   On 2000-08-08 I was told that UNIX 
   is a registered trademark of The Open Group
   in the US and other countries.
        At one point, UNIX was a trademark of AT&amp;T Bell Laboratories.
<li>
   MSDOS is a trademark of Microsoft.
<li>|STAT is not a product of any company or organization.
        <li>|STAT is used at your own risk.
        <li>|STAT should not be used for decision making by non-statisticians.
        <li>|STAT is not robust for large datasets or for highly variable data.
        <li>|STAT is unsupported, but known bugs are removed.
</ul>

<p>
All rights reserved.
No part of this handbook may be reproduced or transmitted
in any form or by any means
without prior written permission from the author.
Non-profit organizations may make copies
provided such copies are not made for resale.
<p>
<ul>
        <li>First Edition:      March 1986
        <li>Second Edition:     September 1986
        <li>Third Edition:      March 1987
        <li>Fourth Edition:     December 2001
</ul>

