<h2><a name="preface">Chapter 0: Preface</a></h2>
<p>

<b>Purpose and Intended Audience of the Handbook</b>
<br>
This handbook is meant to be an introduction to the |STAT programs.
It is not written to teach students how to do data analysis,
although it has been used as a supplementary text in courses.
|STAT users should be familiar with using the hardware and utility
programs (e.g., a text editor) on their systems.
<p>

<b>Comparison With Other Packages</b>
<br>
|STAT has advantages and disadvantages
compared to other statistical packages.
|STAT is not a comprehensive package because it was developed
as needs arose.
So there are deficits in many areas of analysis:
no multivariate analysis other than regression,
and only simple graphics.
Independent of these limitations,
the programs are not designed for use with large data sets or large values;
the programs are usually adequate for data up to a few thousand points.
Also, |STAT is unsupported,
so if you have problems installing or using the programs,
you may be on your own.
Despite these limitations,
|STAT provides you with most analyses reported in research.
|STAT programs run on UNIX and MSDOS, operating systems
popular in educational and research institutions, government, and industry.
The liberal copyright of the programs
allows free copies to be made for multiple machines
provided the programs are not copied for material gain.
|STAT programs integrate easily with other programs,
and this makes it possible for new programs to be added later.
<p>

<b>Distribution Conditions</b>
<br>
CAREFULLY READ THE FOLLOWING CONDITIONS.  IF YOU DO NOT FIND THEM
ACCEPTABLE, YOU SHOULD NOT USE |STAT.
<p>
|STAT IS PROVIDED "AS IS," WITHOUT ANY EXPRESS OR IMPLIED
WARRANTY.  THE USER ASSUMES ALL RISKS OF USING |STAT.  THERE IS NO
CLAIM OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
|STAT MAY NOT BE SUITED TO YOUR NEEDS.  |STAT MAY NOT RUN ON YOUR
PARTICULAR HARDWARE OR SOFTWARE CONFIGURATION.  THE AVAILABILITY OF
AND PROGRAMS IN |STAT MAY CHANGE WITHOUT NOTICE.  NEITHER
MANUFACTURER NOR DISTRIBUTOR BEAR RESPONSIBILITY FOR ANY MISHAP OR
ECONOMIC LOSS RESULTING THEREFROM OF THE USE OF |STAT EVEN IF THE
PROGRAMS PROVE TO BE DEFECTIVE.  |STAT IS NOT INTENDED FOR CONSUMER
USE.
<p>
CASUAL USE BY USERS NOT TRAINED IN STATISTICS, OR BY USERS NOT
SUPERVISED BY PERSONS TRAINED IN STATISTICS, MUST BE AVOIDED.
USERS MUST BE TRAINED AT THEIR OWN EXPENSE TO LEARN TO USE THE
PROGRAMS.  DATA ANALYSIS PROGRAMS MAKE MANY ASSUMPTIONS ABOUT DATA,
THESE ASSUMPTIONS AFFECT THE VALIDITY OF CONCLUSIONS MADE BASED ON
THE PROGRAMS.  REFERENCES TO SOME APPROPRIATE STATISTICAL SOURCES
ARE MADE IN THE |STAT HANDBOOK AND IN THE MANUAL ENTRIES FOR
SPECIFIC PROGRAMS.  |STAT PROGRAMS HAVE NOT BEEN VALIDATED FOR
LARGE DATASETS, HIGHLY VARIABLE DATA, NOR VERY LARGE NUMBERS.
<p>
You may make copies of any tangible forms of |STAT programs,
provided that there is no material gain involved, and provided that
the information in this notice accompanies every copy.  You may not
copy printed documentation unless such duplication is for non-
profit educational purposes.  You may not provide |STAT as an
inducement to buy your software or hardware or any products or
services.  You may distribute copies of |STAT, provided that mass
distribution (such as electronic bulletin boards or anonymous ftp)
is not used.  You may not modify the source code for any purposes
other than getting the programs to work on your system.  Any costs
in compiling or porting |STAT to your system are yours alone, and
not any other parties.  You may not distribute any modified source
code or documentation to users at any sites other than your own.
<p>

<b>References</b>
<br>
<ol>

<li>Bradley, J. V.
     (1968)
     Distribution-Free Statistical Tests.
     Englewood Cliffs, NJ: Prentice-Hall.

<li>Coombs, C. H.,
     Dawes, R. M.,
     &amp;
     Tversky, A.
     (1970)
     Mathematical Psychology: An Elementary Introduction.
     Englewood Cliffs, NJ: Prentice-Hall.

<li>Dixon, W. J.
     (1975)
     BMD-P Biomedical Computer Programs.
     Berkeley, CA: University of California Press.

<li>Guilford, J. P.,
     &amp;
     Fruchter, B.
     (1978)
     Fundamental Statistics in Psychology and Education.
     (6th Edition).
     New York: McGraw-Hill.

<li>Hays, W. L.
     (1973)
     Statistics for the Social Sciences.
     (2nd Edition).
     New York, NY: Holt Rinehart Winston.

<li>Hemenway, K.,
     &amp;
     Armitage, H.
     (1984)
     Proposed Syntax Standard for UNIX System Commands.
     In
     Summer USENIX Conference.
     El Cerito, CA: Usenix Association.
     (Washington, DC.)

<li>Keppel, G.
     (1973)
     Design and Analysis: A Researcher's Handbook.
     Englewood Cliffs, NJ: Prentice-Hall.

<li>Kerlinger, F. N.,
     &amp;
     Pedhazur, E. J.
     (1973)
     Multiple Regression in Behavioral Research.
     New York, NY: Holt Rinehart Winston.



<li>Kernighan, B. W.,
     &amp;
     Ritchie, D. M.
     (1979)
     The C Programming Language.
     Englewood Cliffs, NJ: Prentice-Hall.

<li>Nie, H. H.,
     Jenkins, J. G.,
     Steinbrenner, K.,
     &amp;
     Bent, D. H.
     (1975)
     SPSS: Statistical Package for the Social Sciences.
     New York: McGraw-Hill.

<li>Perlman, G.
     (1980)
     Data Analysis Programs for the UNIX Operating System.
     Behavior Research Methods &amp; Instrumentation,
     12:5,
     554-558.

<li>Perlman, G.
     (1982)
     Data Analysis in the UNIX Environment: Techniques for Automated Experimental Design Specification.
     In
     K. W. Heiner,
     R. S. Sacher,
     &amp;
     J. W. Wilkinson
     (Eds.),
     Computer Science and Statistics: Proceedings of the 14th Symposium on the Interface.

<li>Perlman, G.,
     &amp;
     Horan, F. L.
     (1986)
     Report on |STAT Release 5.1 Data Analysis Programs for UNIX and MSDOS.
     Behavior Research Methods, Instruments, &amp; Computers,
     18.2,
     168-176.

<li>Perlman, G.,
     &amp;
     Horan, F. L.
     (1986)
     |STAT: Compact Data Manipulation and Analysis Programs for MSDOS and UNIX - A Tutorial Overview.
     Tyngsboro, MA: Wang Institute of Graduate Studies.

<li>Ritchie, D. M.,
     &amp;
     Thompson, K.
     (1974)
     The UNIX Time-Sharing System.
     Communications of the Association for Computing Machinery,
     17:7,
     365-375.

<li>Ryan, T. A.,
     Joiner, B. L.,
     &amp;
     Ryan, B. F.
     (1976)
     MINITAB Student Handbook.
     North Scituate, MA: Duxbury Press.

<li>Siegel, S.
     (1956)
     Nonparametric Methods for the Behavioral Sciences.
     New York: McGraw-Hill.
</ol>
